Index: anr/task-1.tex
===================================================================
--- anr/task-1.tex	(revision 206)
+++ anr/task-1.tex	(revision 213)
@@ -52,6 +52,6 @@
     document listing all the COACH software components and how they cooperate.
     \begin{livrable}
-      \CoutHorsD{0}{12}{\Sthales}{user specification}{1:0:0}
-    \itemL{0}{6}{d}{\Supmc}{decription of \ganttlf software architecture}{1:0:0}
+      \CoutHorsD{0}{12}{\Sthales}{User specification}{1:0:0}
+    \itemL{0}{6}{d}{\Supmc}{COACH design \ganttlf flow specification}{1:0:0}
         It contains the software list and the data flow among them.
     \end{livrable}
@@ -71,35 +71,35 @@
         Last release of XML specification of the \xcoach format enhanced with
         the expression of loop potential parallelism.
-    \itemV{6}{12}{x}{\Subs}{C/C++ $\leftrightarrow$ \xcoach format (1)}{2:0:0}
+    \itemV{6}{12}{x}{\Subs}{First release of C2X}
         \setMacroInAuxFile{specXcoachToCAI}
         A GCC plugin C2X that generates a \xcoach description
         (defined in {\specXcoachDocI} deliverable) from a C/C++ task description
         (defined in {\specHasManual} deliverable).
-    \itemL{12}{18}{x}{\Subs}{C++ $\leftrightarrow$ \xcoach format (1)}{2:1:0}
+    \itemL{12}{18}{x}{\Subs}{Final release of C2X}{2:1:0}
         \setMacroInAuxFile{specXcoachToCA}
          An updated version of C2X (\specXcoachToCAI) which supports the \xcoach format defined
         in the {\specXcoachDoc} deliverable and the HAS input format defined in the {\specHasManual}
         deliverable.
-    \itemV{7}{12}{x}{\Subs}{C/C++ $\leftrightarrow$ \xcoach format (2)}{2:0:0}
+    \itemV{7}{12}{x}{\Subs}{First release of X2C}
         \setMacroInAuxFile{specXcoachToCBI}
         This second tool X2C regenerates a C description from a \xcoach
         description.
-    \itemL{12}{18}{x}{\Subs}{C++ $\leftrightarrow$ \xcoach format (2)}{2:1:0}
+    \itemL{12}{18}{x}{\Subs}{Final release of X2C}{2:1:0}
         \setMacroInAuxFile{specXcoachToCB}
         The same software as the former (\specXcoachToCBI) but for the \xcoach format as defined
         in the {\specXcoachDoc} deliverable and HAS input as defined in the {\specHasManual}
         deliverable.
-    \itemV{12}{18}{x}{\Supmc}{\xcoachplus format to SystemC}
+    \itemV{12}{18}{x}{\Supmc}{First release of X2SC}
         \setMacroInAuxFile{specXcoachToSystemCI}
         The first release of the software tool X2SC  that translates \xcoachplus description to CABA
         and TLM-DT SystemC module.
-    \itemL{18}{24}{x}{\Supmc}{\xcoachplus format to SystemC}{0:2:0}
+    \itemL{18}{24}{x}{\Supmc}{Final release of X2SC}{0:2:0}
         \setMacroInAuxFile{specXcoachToSystemC}
         Final release of the former software (\specXcoachToSystemCI).
-    \itemV{12}{18}{x}{\Subs}{\xcoachplus format to VHDL}{0:2:0}
+    \itemV{12}{18}{x}{\Subs}{First release of the X2VHDL}
         \setMacroInAuxFile{specXcoachToVhdlI}
-        The first release of the softwaretool X2VHDL that translates \xcoachplus description to
+        The first release of the software tool X2VHDL that translates \xcoachplus description to
         synthesizable VHDL description.
-    \itemL{18}{24}{x}{\Subs}{\xcoachplus format to VHDL}{0:3:0}
+    \itemL{18}{24}{x}{\Subs}{Final release of the X2VHDL}{0:3:0}
         \setMacroInAuxFile{specXcoachToVhdl}
         Final release of the former software (\specXcoachToVhdlI) and integration
@@ -118,5 +118,5 @@
     \itemL{0}{3}{d}{\Subs}{GCC/xcoach driver definition}{1:0:0}
         Specification of the GCC driver tool.
-    \itemV{3}{9}{x}{\Subs}{GCC/xcoach driver generator}{2:0:0}
+    \itemV{3}{9}{x}{\Subs}{GCC/xcoach driver generator}
         First release of the GCC driver tool.
 	%en T0+18 car va peut etre evoluer en fonction du DSE Âµ-archi
@@ -131,8 +131,8 @@
     and by extracting their delays. This is done by using RTL synthesis.
     \begin{livrable}
-    \itemL{0}{6}{d}{\Subs}{macro-cell definition}{1:0:0}
+    \itemL{0}{6}{d}{\Subs}{Macro-cell definition}{1:0:0}
         \setMacroInAuxFile{specMacroCell}
         Definition of the macro cells and the file format describing them.
-    \itemL{6}{12}{x}{\Subs}{macro-cell library generator}{2:0:0}
+    \itemL{6}{12}{x}{\Subs}{Macro-cell library generator}{2:0:0}
         Final release of the software tool that generates automatically the characterized macro-cell library
         for a FPGA device.