Index: anr/architecture-hls.fig
===================================================================
--- anr/architecture-hls.fig	(revision 21)
+++ anr/architecture-hls.fig	(revision 225)
@@ -1,3 +1,3 @@
-#FIG 3.2  Produced by xfig version 3.2.5
+#FIG 3.2  Produced by xfig version 3.2.5b
 Landscape
 Center
@@ -8,14 +8,4 @@
 -2
 1200 2
-6 1044 114 2472 1542
-6 1044 114 2472 1542
-6 1270 430 2245 1225
-4 1 0 50 -1 2 16 0.0000 4 195 780 1757 625 task of\001
-4 1 0 50 -1 2 16 0.0000 4 195 975 1757 895 network\001
-4 1 0 50 -1 2 16 0.0000 4 195 855 1757 1165 process\001
--6
-1 4 0 2 0 7 50 -1 -1 6.000 1 0.0000 1758 828 699 699 1061 791 2456 866
--6
--6
 6 4680 -855 6120 -270
 2 2 1 2 0 7 50 -1 -1 6.000 0 0 -1 0 0 5
@@ -28,24 +18,38 @@
 4 1 0 50 -1 2 14 0.0000 4 165 705 5397 945 xcoach\001
 -6
-6 9617 1003 12792 1470
-2 1 0 2 0 7 50 -1 -1 0.000 0 0 7 1 0 2
-	0 0 2.00 120.00 240.00
-	 9632 1165 10302 1165
-2 1 0 2 0 7 50 -1 -1 6.000 0 0 -1 1 0 2
-	0 0 2.00 120.00 240.00
-	 10747 1175 11377 1175
-2 2 1 2 0 7 50 -1 -1 6.000 0 0 -1 0 0 5
-	 10300 1018 10750 1018 10750 1243 10300 1243 10300 1018
-4 0 0 50 -1 2 16 0.0000 4 225 1335 11457 1410 component\001
-4 0 0 50 -1 2 16 0.0000 4 195 825 11427 1225 VHDL\001
--6
-6 6435 -1140 8010 210
 6 6878 -720 7613 -195
 4 1 0 50 -1 2 14 0.0000 4 225 735 7245 -255 library\001
 4 1 0 50 -1 2 14 0.0000 4 165 360 7245 -555 cell\001
 -6
-2 4 1 2 0 7 50 -1 -1 6.000 0 0 7 0 0 5
-	 7785 -15 7785 -915 6660 -915 6660 -15 7785 -15
+6 6615 -1125 7875 45
+5 1 1 2 0 7 50 -1 -1 4.000 0 1 0 0 7269.206 -978.870 6644 -211 7188 8 7846 -174
+1 1 1 2 0 7 50 -1 -1 4.000 1 0.0000 7245 -942 602 146 7245 -942 7846 -942
+2 1 1 2 0 7 50 -1 -1 4.000 0 0 -1 0 0 2
+	 6644 -942 6644 -211
+2 1 1 2 0 7 50 -1 -1 4.000 0 0 -1 0 0 2
+	 7846 -906 7846 -174
 -6
+6 10260 450 11430 855
+2 1 0 2 0 7 50 -1 -1 6.000 0 0 -1 1 0 2
+	0 0 2.00 120.00 240.00
+	 10980 675 11377 652
+2 2 1 2 0 7 50 -1 -1 6.000 0 0 -1 0 0 5
+	 10305 495 10980 495 10980 810 10305 810 10305 495
+-6
+6 10260 990 11430 1395
+2 1 0 2 0 7 50 -1 -1 6.000 0 0 -1 1 0 2
+	0 0 2.00 120.00 240.00
+	 10980 1215 11377 1192
+2 2 1 2 0 7 50 -1 -1 6.000 0 0 -1 0 0 5
+	 10305 1035 10980 1035 10980 1350 10305 1350 10305 1035
+-6
+6 10260 1440 11430 1845
+2 1 0 2 0 7 50 -1 -1 6.000 0 0 -1 1 0 2
+	0 0 2.00 120.00 240.00
+	 10980 1665 11377 1642
+2 2 1 2 0 7 50 -1 -1 6.000 0 0 -1 0 0 5
+	 10305 1485 10980 1485 10980 1800 10305 1800 10305 1485
+-6
+1 4 0 2 0 7 50 -1 -1 6.000 1 0.0000 1758 828 699 699 1061 791 2456 866
 2 2 0 2 0 7 50 -1 -1 6.000 0 0 7 0 0 5
 	 3150 225 4275 225 4275 900 3150 900 3150 225
@@ -72,17 +76,7 @@
 2 4 1 2 0 7 50 -1 -1 6.000 0 0 7 0 0 5
 	 9585 1395 9585 450 8550 450 8550 1395 9585 1395
-2 1 0 2 0 7 50 -1 -1 6.000 0 0 -1 1 0 2
-	0 0 2.00 120.00 240.00
-	 10747 652 11377 652
 2 1 0 2 0 7 50 -1 -1 0.000 0 0 7 1 0 2
 	0 0 2.00 120.00 240.00
 	 9632 642 10302 642
-2 2 1 2 0 7 50 -1 -1 6.000 0 0 -1 0 0 5
-	 10260 495 10710 495 10710 720 10260 720 10260 495
-2 1 0 2 0 7 50 -1 -1 6.000 0 0 -1 1 0 2
-	0 0 2.00 120.00 240.00
-	 10767 1662 11397 1662
-2 2 1 2 0 7 50 -1 -1 6.000 0 0 -1 0 0 5
-	 10300 1530 10750 1530 10750 1755 10300 1755 10300 1530
 2 1 0 2 0 7 50 -1 -1 0.000 0 0 7 1 0 2
 	0 0 2.00 120.00 240.00
@@ -95,10 +89,21 @@
 	0 0 2.00 120.00 240.00
 	 7249 -8 7245 540
+2 4 1 2 0 7 50 -1 -1 6.000 0 0 7 0 0 5
+	 9585 1395 9585 450 8550 450 8550 1395 9585 1395
+2 1 0 2 0 7 50 -1 -1 0.000 0 0 7 1 0 2
+	0 0 2.00 120.00 240.00
+	 9632 1170 10302 1170
 4 1 0 50 -1 2 14 0.0000 4 165 705 3690 1125 xcoach\001
 4 1 0 50 -1 2 14 0.0000 4 165 645 3690 1425 driver\001
 4 1 0 50 -1 2 14 0.0000 4 180 330 3690 630 gcc\001
 4 1 0 50 -1 2 14 0.0000 4 165 840 9042 945 xcoach+\001
-4 0 0 50 -1 2 16 0.0000 4 255 1065 11397 602 SystemC\001
-4 0 0 50 -1 2 16 0.0000 4 195 735 11417 827 model\001
-4 0 0 50 -1 2 16 0.0000 4 195 990 11427 1762 C model\001
 4 0 0 50 -1 2 14 0.0000 4 165 945 6795 945 back-end\001
+4 1 0 50 -1 2 16 0.0000 4 195 975 1757 1165 network\001
+4 1 0 50 -1 2 16 0.0000 4 195 855 1757 895 process\001
+4 1 0 50 -1 2 16 0.0000 4 195 780 1757 625 task of\001
+4 0 0 50 -1 0 12 0.0000 4 150 525 10395 720 X2SC\001
+4 0 0 50 -1 0 12 0.0000 4 150 570 10395 1260 X2vhd\001
+4 0 0 50 -1 2 16 0.0000 4 195 825 11385 1260 VHDL\001
+4 0 0 50 -1 2 16 0.0000 4 255 1065 11430 720 SystemC\001
+4 0 0 50 -1 2 16 0.0000 4 195 195 11430 1755 C\001
+4 0 0 50 -1 0 12 0.0000 4 150 405 10395 1710 X2C\001