Index: anr/flow.fig
===================================================================
--- anr/flow.fig	(revision 1)
+++ anr/flow.fig	(revision 226)
@@ -1,3 +1,3 @@
-#FIG 3.2
+#FIG 3.2  Produced by xfig version 3.2.5b
 Landscape
 Center
@@ -16,22 +16,6 @@
 5 1 1 1 0 7 50 -1 -1 4.000 0 1 1 0 9315.226 707.707 8775 5100 10575 4950 12300 3975
 	1 1 1.00 60.00 120.00
-6 7575 3825 9675 5850
 5 1 0 2 0 7 50 -1 -1 0.000 0 1 1 0 8562.500 4437.500 8850 4950 9075 4725 9150 4425
 	1 1 2.00 60.00 120.00
-1 4 0 2 0 7 50 -1 -1 0.000 1 0.0000 8595 5027 228 228 8367 5027 8823 5027
-1 4 0 2 0 7 50 -1 -1 0.000 1 0.0000 8103 4200 228 228 7875 4200 8331 4200
-1 4 0 2 0 7 50 -1 -1 0.000 1 0.0000 9118 4213 228 228 8890 4213 9346 4213
-2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
-	1 1 2.00 60.00 120.00
-	 8925 4200 8325 4200
-2 1 1 2 0 7 50 -1 -1 4.000 0 0 -1 0 0 2
-	 7650 5325 9600 5325
-2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
-	 9600 5775 7650 5775 7650 3900 9600 3900 9600 5775
-4 0 0 50 -1 2 12 0.0000 4 135 225 8475 5100 T0\001
-4 0 0 50 -1 2 12 0.0000 4 135 225 8025 4275 T1\001
-4 0 0 50 -1 2 12 0.0000 4 135 225 9000 4275 T2\001
-4 0 0 50 -1 2 16 0.0000 4 165 1710 7800 5625 Process network\001
--6
 6 4275 2475 6675 4950
 2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
@@ -45,18 +29,12 @@
 2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
 	 6600 4875 4350 4875 4350 2550 6600 2550 6600 4875
-4 0 0 50 -1 2 16 0.0000 4 225 1635 4650 3075 Application PC\001
-4 0 0 50 -1 2 16 0.0000 4 225 1740 4575 4425 Application SoC\001
+4 0 0 50 -1 2 16 0.0000 4 255 1815 4650 3075 Application PC\001
+4 0 0 50 -1 2 16 0.0000 4 255 1950 4575 4425 Application SoC\001
 -6
 6 1725 3300 3375 4275
 2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
 	 3300 4200 1800 4200 1800 3375 3300 3375 3300 4200
-4 0 0 50 -1 2 16 0.0000 4 165 495 2325 3750 HPC\001
-4 0 0 50 -1 2 16 0.0000 4 225 1185 1950 4050 application\001
--6
-6 1725 4800 3375 5775
-2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
-	 3300 5700 1800 5700 1800 4875 3300 4875 3300 5700
-4 0 0 50 -1 2 16 0.0000 4 165 1095 2025 5250 Embedded\001
-4 0 0 50 -1 2 16 0.0000 4 225 1185 1950 5550 application\001
+4 0 0 50 -1 2 16 0.0000 4 195 585 2325 3750 HPC\001
+4 0 0 50 -1 2 16 0.0000 4 255 1335 1950 4050 application\001
 -6
 6 7500 975 9750 3675
@@ -64,8 +42,8 @@
 6 7725 1125 8175 2775
 6 7800 1275 8100 2175
-4 1 0 50 -1 2 16 0.0000 4 165 150 7950 1500 P\001
-4 1 0 50 -1 2 16 0.0000 4 165 180 7950 1725 R\001
-4 1 0 50 -1 2 16 0.0000 4 165 180 7950 1950 O\001
-4 1 0 50 -1 2 16 0.0000 4 165 165 7949 2175 C\001
+4 1 0 50 -1 2 16 0.0000 4 195 165 7950 1500 P\001
+4 1 0 50 -1 2 16 0.0000 4 195 195 7950 1725 R\001
+4 1 0 50 -1 2 16 0.0000 4 195 225 7950 1950 O\001
+4 1 0 50 -1 2 16 0.0000 4 195 195 7949 2175 C\001
 -6
 2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
@@ -74,7 +52,7 @@
 6 8175 1125 8625 2775
 6 8250 1275 8550 1950
-4 1 0 50 -1 2 16 0.0000 4 165 180 8400 1500 R\001
-4 1 0 50 -1 2 16 0.0000 4 165 180 8400 1725 A\001
-4 1 0 50 -1 2 16 0.0000 4 165 225 8400 1950 M\001
+4 1 0 50 -1 2 16 0.0000 4 195 195 8400 1500 R\001
+4 1 0 50 -1 2 16 0.0000 4 195 195 8400 1725 A\001
+4 1 0 50 -1 2 16 0.0000 4 195 255 8400 1950 M\001
 -6
 2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
@@ -84,11 +62,11 @@
 2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
 	 8700 1200 9000 1200 9000 2700 8700 2700 8700 1200
-4 1 0 50 -1 2 16 0.0000 4 165 90 8850 1500 I\001
-4 1 0 50 -1 2 16 0.0000 4 165 180 8850 1725 O\001
+4 1 0 50 -1 2 16 0.0000 4 195 105 8850 1500 I\001
+4 1 0 50 -1 2 16 0.0000 4 195 225 8850 1725 O\001
 -6
 6 7725 2775 9525 3225
 2 2 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
 	 7800 2850 9450 2850 9450 3150 7800 3150 7800 2850
-4 1 0 50 -1 2 16 0.0000 4 165 465 8625 3075 BUS\001
+4 1 0 50 -1 2 16 0.0000 4 195 540 8625 3075 BUS\001
 -6
 -6
@@ -97,5 +75,5 @@
 2 1 1 2 0 7 50 -1 -1 6.000 0 0 -1 0 0 2
 	 7575 3300 9675 3300
-4 1 0 50 -1 2 16 0.0000 4 165 945 8625 3525 Platform\001
+4 1 0 50 -1 2 16 0.0000 4 195 1080 8625 3525 Platform\001
 -6
 6 10575 2250 12825 4950
@@ -103,8 +81,8 @@
 6 10800 2400 11250 4050
 6 10875 2550 11175 3450
-4 1 0 50 -1 2 16 0.0000 4 165 150 11025 2775 P\001
-4 1 0 50 -1 2 16 0.0000 4 165 180 11025 3000 R\001
-4 1 0 50 -1 2 16 0.0000 4 165 180 11025 3225 O\001
-4 1 0 50 -1 2 16 0.0000 4 165 165 11024 3450 C\001
+4 1 0 50 -1 2 16 0.0000 4 195 165 11025 2775 P\001
+4 1 0 50 -1 2 16 0.0000 4 195 195 11025 3000 R\001
+4 1 0 50 -1 2 16 0.0000 4 195 225 11025 3225 O\001
+4 1 0 50 -1 2 16 0.0000 4 195 195 11024 3450 C\001
 -6
 2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
@@ -113,7 +91,7 @@
 6 11250 2400 11700 4050
 6 11325 2550 11625 3225
-4 1 0 50 -1 2 16 0.0000 4 165 180 11475 2775 R\001
-4 1 0 50 -1 2 16 0.0000 4 165 180 11475 3000 A\001
-4 1 0 50 -1 2 16 0.0000 4 165 225 11475 3225 M\001
+4 1 0 50 -1 2 16 0.0000 4 195 195 11475 2775 R\001
+4 1 0 50 -1 2 16 0.0000 4 195 195 11475 3000 A\001
+4 1 0 50 -1 2 16 0.0000 4 195 255 11475 3225 M\001
 -6
 2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
@@ -123,15 +101,15 @@
 2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
 	 11775 2475 12075 2475 12075 3975 11775 3975 11775 2475
-4 1 0 50 -1 2 16 0.0000 4 165 90 11925 2775 I\001
-4 1 0 50 -1 2 16 0.0000 4 165 180 11925 3000 O\001
+4 1 0 50 -1 2 16 0.0000 4 195 105 11925 2775 I\001
+4 1 0 50 -1 2 16 0.0000 4 195 225 11925 3000 O\001
 -6
 6 12150 2400 12600 4050
 6 12225 2475 12525 3825
-4 1 0 50 -1 2 16 0.0000 4 165 150 12375 3150 P\001
-4 1 0 50 -1 2 16 0.0000 4 165 180 12375 3375 R\001
-4 1 0 50 -1 2 16 0.0000 4 165 180 12375 3600 O\001
-4 1 0 50 -1 2 16 0.0000 4 165 165 12374 3825 C\001
-4 1 0 50 -1 2 16 0.0000 4 165 180 12375 2925 O\001
-4 1 0 50 -1 2 16 0.0000 4 165 165 12375 2700 C\001
+4 1 0 50 -1 2 16 0.0000 4 195 165 12375 3150 P\001
+4 1 0 50 -1 2 16 0.0000 4 195 195 12375 3375 R\001
+4 1 0 50 -1 2 16 0.0000 4 195 225 12375 3600 O\001
+4 1 0 50 -1 2 16 0.0000 4 195 195 12374 3825 C\001
+4 1 0 50 -1 2 16 0.0000 4 195 225 12375 2925 O\001
+4 1 0 50 -1 2 16 0.0000 4 195 195 12375 2700 C\001
 -6
 2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
@@ -141,5 +119,5 @@
 2 2 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
 	 10875 4125 12525 4125 12525 4425 10875 4425 10875 4125
-4 1 0 50 -1 2 16 0.0000 4 165 465 11700 4350 BUS\001
+4 1 0 50 -1 2 16 0.0000 4 195 540 11700 4350 BUS\001
 -6
 -6
@@ -148,16 +126,22 @@
 2 1 1 2 0 7 50 -1 -1 6.000 0 0 -1 0 0 2
 	 10650 4575 12750 4575
-4 1 0 50 -1 2 16 0.0000 4 165 945 11700 4800 Platform\001
+4 1 0 50 -1 2 16 0.0000 4 195 1080 11700 4800 Platform\001
 -6
 6 11100 300 12375 900
-4 0 0 50 -1 2 16 0.0000 4 225 1245 11100 525 Application\001
-4 0 0 50 -1 2 16 0.0000 4 225 1245 11100 825 compilation\001
+4 0 0 50 -1 2 16 0.0000 4 255 1395 11100 525 Application\001
+4 0 0 50 -1 2 16 0.0000 4 255 1425 11100 825 compilation\001
 -6
+6 1725 4650 3375 5625
+2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
+	 3300 5550 1800 5550 1800 4725 3300 4725 3300 5550
+4 0 0 50 -1 2 16 0.0000 4 195 1245 2025 5100 Embedded\001
+4 0 0 50 -1 2 16 0.0000 4 255 1335 1950 5400 application\001
+-6
+1 4 0 2 0 7 50 -1 -1 0.000 1 0.0000 8595 5027 228 228 8367 5027 8823 5027
+1 4 0 2 0 7 50 -1 -1 0.000 1 0.0000 8103 4200 228 228 7875 4200 8331 4200
+1 4 0 2 0 7 50 -1 -1 0.000 1 0.0000 9118 4213 228 228 8890 4213 9346 4213
 2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
 	1 1 2.00 60.00 120.00
 	 6600 4425 7650 4425
-2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
-	1 1 2.00 60.00 120.00
-	 3300 5325 7650 5325
 2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
 	1 1 2.00 60.00 120.00
@@ -167,7 +151,4 @@
 2 1 1 2 0 7 50 -1 -1 4.000 0 0 -1 0 0 2
 	 10125 150 10125 6450
-2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 1 2
-	1 1 2.00 60.00 120.00
-	 8550 6450 8550 5775
 2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 1 2
 	1 1 2.00 60.00 120.00
@@ -180,9 +161,26 @@
 2 1 1 2 0 7 50 -1 -1 4.000 0 0 -1 0 0 2
 	 3750 150 3750 6450
-4 0 0 50 -1 2 16 0.0000 4 165 1140 4875 6750 Evaluation\001
-4 0 0 50 -1 2 16 0.0000 4 165 1140 8025 6750 Evaluation\001
-4 0 0 50 -1 2 16 0.0000 4 165 1140 11100 1650 Executable\001
-4 0 0 50 -1 2 16 0.0000 4 225 915 11250 6750 Running\001
-4 0 0 50 -1 2 16 0.0000 4 225 585 2250 675 Input\001
-4 0 0 50 -1 2 16 0.0000 4 225 1125 4800 675 HPC setup\001
-4 0 0 50 -1 2 16 0.0000 4 225 1155 8025 675 SoC design\001
+2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	1 1 2.00 60.00 120.00
+	 3300 5175 7650 5175
+2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	1 1 2.00 60.00 120.00
+	 8925 4200 8325 4200
+2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 1 2
+	1 1 2.00 60.00 120.00
+	 8550 6450 8550 5775
+2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
+	 9600 5775 7650 5775 7650 3900 9600 3900 9600 5775
+2 1 1 2 0 7 50 -1 -1 4.000 0 0 -1 0 0 2
+	 7650 5325 9600 5325
+4 0 0 50 -1 2 16 0.0000 4 195 1305 11100 1650 Executable\001
+4 0 0 50 -1 2 16 0.0000 4 255 1065 11250 6750 Running\001
+4 0 0 50 -1 2 16 0.0000 4 255 690 2250 675 Input\001
+4 0 0 50 -1 2 16 0.0000 4 255 1290 4800 675 HPC setup\001
+4 0 0 50 -1 2 16 0.0000 4 255 1305 8025 675 SoC design\001
+4 0 0 50 -1 2 12 0.0000 4 150 240 8475 5100 T0\001
+4 0 0 50 -1 2 12 0.0000 4 150 240 8025 4275 T1\001
+4 0 0 50 -1 2 12 0.0000 4 150 240 9000 4275 T2\001
+4 0 0 50 -1 2 16 0.0000 4 195 1905 7725 5625 Process network\001
+4 0 0 50 -1 2 16 0.0000 4 255 2535 4200 6750 Performance analysis\001
+4 0 0 50 -1 2 16 0.0000 4 255 2535 7350 6750 Performance analysis\001